Subject: Re: bug#36941: Please include option to link to maildir files

From: Jean Louis <[email-masked]>
Date: Sun, 18 Aug 2019 20:59:16 +0200

* Robert Weiner <[email-masked]> [2019-08-18 19:55]:
> > 'link-to-mail'
> >      Displays a mail message with MAIL-MSG-ID from optional MAIL-FILE.
> >      See the documentation for the variable 'hmail:init-function' for
> >      information on how to specify the mail reader to use.
> >
> > MAIL-MSG-ID is not necessary for maildir messages, as it is almost
> > same as link to file, the difference would be that some headers could
> > be hidden and message or mail mode would be turned on. Messages could
> > be replied, forwarded, etc.
> >
> > Maybe some action can be used for maildirs, just skipping the
> > MAIL-MSG-ID. But it somehow need to know if it is maildir link by
> > asking the user.
> >
> 
> I am still unclear on precisely what you would want.
> 
> Do you want a Hyperbole action type that links to maildir messages where
> you would specify the full path to the maildir message file and Hyperbole
> would display the message in the mail reader that you assigned to
> hmail:reader variable?  Then you could use that in explicit button and
> implicit button type definitions.
> 
> Do you want an implicit button type that recognizes maildir message ids in
> buffers?
> 
> Something else?

Thank you Bob.

You have created `link-to-mail`. But that probably means to link to
mail message in mbox file. I cannot be so sure, as I do not use mbox
format.

Maildir format is well known, it is already standard for many pieces
of software[1][2][3][4].

As part of the `link-to-mail` function I propose that you expand the
function that it supports to link to mail file which is part of
maildir format. That is explicit button extension to your function
which does not support maildirs.

Example maildir directory is shown here:

  /home/data1/protected/Maildir/[email-masked]:
  insgesamt 12K
  drwx------ 2 4,0K 12. Aug 13:04 cur
  drwx------ 2 4,0K 23. Nov 2017  new
  drwx------ 2 4,0K 12. Aug 13:04 tmp

Example messages in `cur` are shown here:

  /home/data1/protected/Maildir/[email-masked]/cur:
  insgesamt 16K
  -rw------- 1 6,0K 23. Nov 2017  1511412843.18643_5.protected:2,S
  -rw------- 1 4,6K 11. Aug 17:58 1565607852.20344_65.protected:2,S

Thus to link to certain message in Maildir format is equivalent to
linking it to the file such as it is:

/home/data1/protected/Maildir/[email-masked]/cur/1511412843.18643_5.protected:2,S

and turning on certain mode to read such message, maybe message-mode
in read-only mode, this I do not know.

I have 300,000 messages in Maildir format, and very few in mbox
format.

Jean

Footnotes:
[1]  https://en.wikipedia.org/wiki/Maildir

[2]  https://wiki2.dovecot.org/MailboxFormat/Maildir

[3]  https://cr.yp.to/proto/maildir.html

[4]  http://www.courier-mta.org/maildir.html